// Colour.cpp: implementation of the CColour class.

#include "Colour.h"
#include <iostream>
using namespace std;

CColour::CColour(){ r=0.0f; g=0.0f; b=0.0f;}

CColour::CColour(float r, float g, float b){ setColour(r,g,b);}

CColour::~CColour(){}

void CColour::setColour(float r, float g, float b){ 
	this->r=r; this->g=g; this->b=b;}

void CColour::print(){
	cout << "(" << r << ", " << g << ", " << b << ")";}

CColour CColour::mixColour(CColour c2){
		return CColour(0.5f*(r+c2.r), 0.5f*(g+c2.g), 0.5f*(b+c2.b));}

ostream& operator<<(ostream& s, const CColour& c){
	cout << "(" << c.r << ", " << c.g << ", " << c.b << ")";
	return s;}

CColour mixColour(CColour c1, CColour c2){
		return CColour(0.5f*(c1.r+c2.r), 0.5f*(c1.g+c2.g), 0.5f*(c1.b+c2.b));}





CColourWithTransparency::CColourWithTransparency(){ r=0.0f; g=0.0f; b=0.0f; t=0.0f;}

CColourWithTransparency::CColourWithTransparency(float r, float g, float b, float t){ setColour(r,g,b,t);}

CColourWithTransparency::~CColourWithTransparency(){}

void CColourWithTransparency::setColour(float r, float g, float b, float t){ 
	CColour::setColour(r,g,b); this->t=t;}

void CColourWithTransparency::print(){
	cout << "(" << r << ", " << g << ", " << b << ", " << t << ")";}

CColourWithTransparency CColourWithTransparency::mixColour(CColourWithTransparency c2){
		return CColourWithTransparency(0.5f*(r+c2.r), 0.5f*(g+c2.g), 0.5f*(b+c2.b), 0.5f*(t+c2.t));}
