// Colour.h: interface of the CColour class.

#if !defined(LECTURE372_CCOLOUR)
#define LECTURE372_CCOLOUR

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <iostream>
using namespace std;

class CColour
{
public:
	CColour();
	CColour(float r, float g, float b);
	virtual ~CColour();
	void setColour(float r, float g, float b);	
	void print();
	CColour mixColour(CColour c2);
	friend ostream& operator<<(ostream& s, const CColour& c);
	friend CColour mixColour(CColour c1, CColour c2);
protected:			// must make attributes 'protected' so that they can be 
	float r,g,b;	// accessed by the subclass
};

class CColourWithTransparency:public CColour
{
public:
	CColourWithTransparency();
	CColourWithTransparency(float r, float g, float b, float t);
	virtual ~CColourWithTransparency();
	void setColour(float r, float g, float b, float t);	
	void print();
	CColourWithTransparency mixColour(CColourWithTransparency c2);
private:
	float t;
};

#endif // !defined(LECTURE372_CCOLOUR)
